//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

IncludeScript("gungame/mercenary/character.nut");
IncludeScript("gungame/mercenary/weapon_models.nut");
IncludeScript("gungame/mercenary/bhop.nut");

::GivePlayerWeapon <- function(player, className, itemID, script = null)
{
    for (local i = 0; i < 10; i++)
    {
        local heldWeapon = GetPropEntityArray(player, "m_hMyWeapons", i);
        if (!heldWeapon || (!IsSwordClass(className) && heldWeapon.GetSlot() == 2))
            continue;
        heldWeapon.Destroy();
        SetPropEntityArray(player, "m_hMyWeapons", null, i);
    }

    local weapon;
    if (script != null)
    {
        weapon = SpawnEntityFromTable(className,
        {
            vscripts = script,
            thinkfunction = "Think",
        });
    }
    else
        weapon = Entities.CreateByClassname(className);
    SetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", itemID);
    SetPropBool(weapon, "m_AttributeManager.m_Item.m_bInitialized", true);
    SetPropBool(weapon, "m_bValidatedAttachedEntity", true);
	SetPropBool(weapon, "m_bClientSideAnimation", true);
    weapon.SetTeam(player.GetTeam());
    SetPropBool(weapon, "m_bForcePurgeFixedupStrings", true);
    Entities.DispatchSpawn(weapon);

    player.Weapon_Equip(weapon);
    player.Weapon_Switch(weapon);
    SetPropEntity(player, "m_hActiveWeapon", weapon);
    for (local i = 0; i < 10; i++)
    {
        local melee = GetPropEntityArray(player, "m_hMyWeapons", i);
        if (melee && melee.GetSlot() == 2)
        {
            SetPropEntity(player, "m_hLastWeapon", melee);
            break;
        }
    }

    return weapon;
}

::GivePlayerWeapon2 <- function(player, className, itemID, script = null)
{
    local weapon;
    if (script != null)
    {
        weapon = SpawnEntityFromTable(className,
        {
            vscripts = script,
            thinkfunction = "Think",
        });
    }
    else
        weapon = Entities.CreateByClassname(className);
    SetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", itemID);
    SetPropBool(weapon, "m_AttributeManager.m_Item.m_bInitialized", true);
    SetPropBool(weapon, "m_bValidatedAttachedEntity", true);
	SetPropBool(weapon, "m_bClientSideAnimation", true);
    weapon.SetTeam(player.GetTeam());
    SetPropBool(weapon, "m_bForcePurgeFixedupStrings", true);
    Entities.DispatchSpawn(weapon);

    player.Weapon_Equip(weapon);
    player.Weapon_Switch(weapon);

    return weapon;
}